package main

import (
	"context"
	"encoding/json"
	"gitea.cdlsxd.cn/sdk/plugin/instance"
	"gitea.cdlsxd.cn/sdk/plugin/manage"
	"gitea.cdlsxd.cn/sdk/plugin/proto"
	"log"
	"plugins/utils/wechat"
)

var wechatRedPackConf = &manage.Config{
	Cmd:         "pkg/mac/wechat_redpack.so",
	Tag:         "wechat_redpack",
	Version:     1,
	CookieKey:   "wechat_redpack",
	CookieValue: "wechat_redpack",
}

func getWechatRedPackConf() []byte {
	c := &wechat.Server{
		MchID:                      "1629276485",
		MchCertificateSerialNumber: "3C7E21B74C04BE6227A690EB44184F219D763F92",
	}
	marshal, _ := json.Marshal(c)
	return marshal
}

func wechatRedPackOrder() {
	err := manage.Add(wechatRedPackConf)
	if err != nil {
		log.Fatalln(err)
	}
	defer manage.Close()
	//芭乐福利官：wxbfcf9fd93f390c3a
	//芭乐芭乐加油：wx381e6a04ab7f69b6
	req := &proto.OrderRequest{
		Config: getWechatRedPackConf(),
		Order: &proto.OrderRequest_Order{
			OrderNo:  "240403164049635937",
			Account:  "oZ5ge5Vb2UvbEcIc8ZTt_yF7fNx8",
			Amount:   0.01,
			Quantity: 1,
			Extra:    []byte(`{"app_id":"wxbfcf9fd93f390c3a", "out_detail_no":"12345678917"}`),
		},
		Product: &proto.OrderRequest_Product{
			ProductNo: "",
			Extra:     []byte(`{"batch_name":"batch_name", "batch_remark":"batch_remark"}`),
		},
	}
	res, err := instance.Order(context.Background(), wechatRedPackConf.Tag, req)
	if err != nil {
		log.Fatalln(err)
	}
	log.Printf("Order res:%+v", res)
}

func wechatRedPackQuery() {
	err := manage.Add(wechatRedPackConf)
	if err != nil {
		log.Fatalln(err)
	}
	defer manage.Close()
	//芭乐福利官：wxbfcf9fd93f390c3a
	//芭乐芭乐加油：wx381e6a04ab7f69b6
	//{status:ING  order_no:"240403164049635937"  trade_no:"131000609002201499912952024102122461843179"  message:"成功"}
	queryRequest := &proto.QueryRequest{
		Config: getWechatRedPackConf(),
		Order: &proto.QueryRequest_Order{
			OrderNo: "202410181543202661520132",
			TradeNo: "",
			Account: "",
			Extra:   []byte(`{"out_detail_no":"20241018154320266152013216702243"}`),
		},
	}
	resQuery, err := instance.Query(context.Background(), wechatRedPackConf.Tag, queryRequest)
	if err != nil {
		log.Fatalln(err)
	}
	log.Printf("Query res:%+v", resQuery)
}
