package po

import (
	"fmt"
	"plugins/union_pay_redpack/internal/vo"
)

type OrderReq struct {
	ChNlId         string `validate:"required" json:"chnlId"`         // 渠道方代码
	AccessId       string `validate:"required" json:"accessId"`       // 接入方ID
	TransSeq       string `validate:"required" json:"transSeq"`       // 流水号
	TransDtTm      string `validate:"required" json:"transDtTm"`      // 交易日期时间
	InsAcctTp      string `validate:"required" json:"insAcctTp"`      // 机构账户类型
	InsAcctId      string `validate:"required" json:"insAcctId"`      // 机构账户代码-P打头的接入方账户代码
	AcctEntityTp   string `validate:"required" json:"acctEntityTp"`   // UP01-手机号 UP02-卡号 UP03-云闪付注册用户ID
	Mobile         string `validate:"required" json:"mobile"`         // sm4加密手机号
	PointTp        string `validate:"required" json:"pointTp"`        // 默认41-专享红包
	PointId        string `validate:"required" json:"pointId"`        // 积分ID-积分类别代码，41开头的16位数字
	PointAt        string `validate:"required" json:"pointAt"`        // 积分额-单位为分
	DelayIn        string `validate:"required" json:"delayIn"`        // 是否延迟生效-不填则默认0-非延迟生效。0-非延迟生效，1-延迟生效
	TempIn         string `validate:"required" json:"tempIn"`         // 暂存标志-一般默认填写0-非暂存。非暂存代表发给用户后，立即可以使用。0-非暂存 ；1-暂存
	InOutTransFlag string `validate:"required" json:"inOutTransFlag"` // 0-境内交易；1-境外交易
	TransDigest    string `validate:"required" json:"transDigest"`    // 交易摘要-交易摘要，最大200位,赠送积分说明，用于在云闪付APP内向用户展示获取说明-必填
	ValidEndDtTm   string `validate:"required" json:"validEndDtTm"`   // 有效截止时间
}

type OrderResp struct {
	Code    vo.Code    `json:"code"`
	Msg     string     `json:"msg"`
	SubCode vo.SubCode `json:"subCode"`
	SubMsg  string     `json:"subMsg"`
}

func (o *OrderResp) GetMsg() string {
	return fmt.Sprintf("Msg:[%s],SubMsg:[%s],自定处理msg:[%s]", o.Msg, o.SubMsg, o.SubCode.GetMsg())
}
