package internal

import (
	"context"
	"github.com/wechatpay-apiv3/wechatpay-go/services/cashcoupons"
	"plugins/utils/wechat"
)

func srv(ctx context.Context, c *wechat.Server) (*cashcoupons.CouponApiService, error) {
	client, err := wechat.GetClient(ctx, c)
	if err != nil {
		return nil, err
	}
	svc := cashcoupons.CouponApiService{Client: client}
	return &svc, nil
}

func verify(ctx context.Context, c *wechat.Server) error {
	err := c.Verify(ctx, "", "")
	if err != nil {
		return err
	}
	return nil
}
